=== debian/changelog ===
mariadb-connector-c (2.3.0-2) unstable; urgency=low

  [ Daniel Schepler ]
  * New patch to fix compilation of my_context.c on architectures
    other than amd64 and i386 (Closes: #830707)

  [ Otto Kekäläinen ]
  * Make libmariadb-dev-compat conflict libmariadbclient-dev/-compat
    (Closes: #831229)

 -- Otto Kekäläinen <otto@debian.org>  Thu, 14 Jul 2016 13:18:54 +0300

mariadb-connector-c (2.3.0-1) unstable; urgency=low

  [ Otto Kekäläinen ]
  * Fix d/copyright formatting
  * Import new upstream release 2.3.0

  [ Daniel Schepler ]
  * New upstream release.  Closes: #785684.
    + Adds plugins as in MySQL Connector/C, updates mariadb-config
      accordingly with new --plugindir option.  Closes: #770650.
  * Rename source package to reflect upstream renaming to
    MariaDB Connector/C.
  * Rename binary dev packages to reflect that this is now the primary
    MariaDB client library in Debian.
  * Refresh patches.
    + Required major reworking of lib_install_dir.patch to create a
      "DEB" install profile.
    + Drop fix_mariadb_config_cflags.patch as it was merged upstream.
  * New patch: fix_mariadb_config_plugindir.patch to fix the output
    of mariadb_config --plugindir.
  * Configure default Unix socket path to Debian's default of
    /var/lib/mysqld/mysqld.sock.  Closes: #781804.
  * Add symlink /usr/include/mysql -> mariadb in compat package.
  * Add Otto Kekäläinen to Uploaders.

  [ Changes from unreleased 2.0.0-2 ]
  * Add Vcs-* fields to debian/control now that packaging is maintained in
    Alioth git.
  * Added copyright information for zlib among others (Closes: #759717)
  * Add symlink /usr/bin/mysql_config -> mariadb_config in compat package.
    Closes: #766996.

 -- Otto Kekäläinen <otto@debian.org>  Sat, 09 Jul 2016 12:07:00 +0300

mariadb-client-lgpl (2.0.0-1) unstable; urgency=low

  * Initial release.  Closes: #752189.

 -- Daniel Schepler <schepler@debian.org>  Sat, 19 Jul 2014 12:00:19 -0700
