## mariadb-connector-c 2.3.1

=== debian/changelog ===
mariadb-connector-c (2.3.1-1) unstable; urgency=low

  [ Dieter Adriaenssens ]
  * Add DEP-12 formatted upstream metadata file

  [ Otto Kekäläinen ]
  * New upstream release 2.3.1
  * Mark missing Multi-Arch as suggested by Multiarch hinter

 -- Otto Kekäläinen <otto@debian.org>  Thu, 10 Nov 2016 22:40:08 +0200
