=== debian/control ===
--- 
+++ 
@@ -45,6 +45,7 @@
 
 Package: libmariadb-dev-compat
 Architecture: any
+Multi-Arch: same
 Section: libdevel
 Priority: extra
 Depends: libmariadb-dev (= ${binary:Version}), ${misc:Depends}
