## mariadb-connector-c 2.3.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,7 +6,7 @@
 
 SET(CPACK_PACKAGE_VERSION_MAJOR 2)
 SET(CPACK_PACKAGE_VERSION_MINOR 3)
-SET(CPACK_PACKAGE_VERSION_PATCH 0)
+SET(CPACK_PACKAGE_VERSION_PATCH 2)
 SET(CPACK_PACKAGE_VERSION "${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
 
 #Minimum required version is Cmake 2.8.8, since we need to build object libraries
@@ -114,6 +114,8 @@
   ENDIF()
 ENDIF()
 
+INCLUDE(TestBigEndian)
+TEST_BIG_ENDIAN(HAVE_BIGENDIAN)
 
 IF(UNIX)
   SEARCH_LIBRARY(DEFAULT_LIB inet_ntoa "c")
