=== debian/changelog ===
mariadb-connector-c (2.3.2-2) unstable; urgency=low

  [ Georg Richter ]
  * Add patches to fix FTBFS on mips, s390x and potentially many
    other big-endian architechtures too (Closes: #851975)
  * Remove dependency and linkage of mariadb_client

 -- Otto Kekäläinen <otto@debian.org>  Sat, 21 Jan 2017 23:10:59 +0200

mariadb-connector-c (2.3.2-1) unstable; urgency=low

  * New upstream release 2.3.2
    - Includes fix for mariadb_config that emitted trailing binary
      garbage on mips64el (Closes: #850142)
    - Includes fix for missing my_stmt.h (Closes: #849125)

 -- Otto Kekäläinen <otto@debian.org>  Thu, 19 Jan 2017 21:16:14 +0200
