## mariadb-connector-c 2.3.3

=== debian/changelog ===
mariadb-connector-c (2.3.3-1) unstable; urgency=low

  * New upstream version 2.3.3
    - Remove patches that have been applied upstream in
      https://jira.mariadb.org/browse/CONC-226

 -- Otto Kekäläinen <otto@debian.org>  Sat, 03 Jun 2017 11:22:54 +0300
