=== debian/control ===
--- 
+++ 
@@ -7,8 +7,8 @@
 Standards-Version: 3.9.8
 Section: libs
 Homepage: https://mariadb.org/
-Vcs-Browser: http://anonscm.debian.org/cgit/pkg-mysql/mariadb-client-lgpl.git/
-Vcs-Git: git://anonscm.debian.org/pkg-mysql/mariadb-client-lgpl.git
+Vcs-Browser: https://anonscm.debian.org/git/pkg-mysql/mariadb-connector-c.git
+Vcs-Git: https://anonscm.debian.org/git/pkg-mysql/mariadb-connector-c.git
 
 Package: libmariadb-dev
 Section: libdevel
